<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<title>For the programmer</title>
</head>

<body>

<h1 align=center>For The Programmer</h1>

<h2>Packages Description</h2>
<ul>
<li>package <i><b><a href="../doc/edu/uky/mip/package-summary.html">edu.uky.mip</a></b></i><br>
 the basic plug-in file.</li>

<li>package <b><a href="../doc/edu/uky/mip/algorithmdelegate/package-summary.html"><i>edu.uky.mip.algorithmdelegate</i></a></b><br>
  all image processing algorithms.</li>

<li>package <b><a href="../doc/edu/uky/mip/gui/package-summary.html"><i>edu.uky.mip.gui</i></a></b><br>
  Graphics parts: canvas, panel, toolkit panel.</li>

<li>package <i><b><a href="../doc/edu/uky/mip/gui/actiondelegate/package-summary.html">edu.uky.mip.gui.actiondelegate</a></b></i><br>
  push button action delegates</li>

<li>package <i><b><a href="../doc/edu/uky/mip/gui/sessiondelegate/package-summary.html">edu.uky.mip.gui.sessiondelegate</a></b></i><br>
  Session delegates</li>

<li>package <b><a href="../doc/edu/uky/mip/perspective/package-summary.html"><i>edu.uky.mip.perspective</i></a></b><br>
  Perspective page.</li>

<li>package <b><a href="../doc/edu/uky/mip/template/package-summary.html"><i>edu.uky.mip.template</i></a></b><br>
  Basic imaging classes.</li>

<li>package <b><a href="../doc/edu/uky/mip/template/loader/package-summary.html"><i>edu.uky.mip.template.loader<br>
  </i></a></b>Image loaders and interface.</li>

<li>package <b><a href="../doc/edu/uky/mip/template/session/package-summary.html"><i>edu.uky.mip.template.session<br>
  </i></a></b>Basic sessions.</li>

<li>package <b><a href="../doc/edu/uky/mip/views/package-summary.html"><i>edu.uky.mip.views<br>
  </i></a></b>Three views and mediator.</li>
</ul>

<h2>What has been implemented</h2>
<ul>

<li>Defined a common image loader interface for future image loader.</li>

<li>Defined an extension point for adding new image loader.</li>

<li>Defined a simple frame work for adding new algorithm by&nbsp; using Eclipse's
  manifest file (plugin.xml) and delegation mechanism.</li>

<li>Image selection, conversion, and selection listener and change listener.</li>

<li>Implemented a set of image canvases with basic java 2D transform (scaling
  and translation).</li>
<li>Implemented image processing algorithms to show how to process image on
  Eclispe: convolution based sharpen, blur, edge detect;
  contrast and brightness tune for image enhancement; threshold transform</li>
<li>Defined extension point to sessions (each session has a button on toolkit
  panel).</li>
<li>Contributed to context menu extension point and also keep it available to
  future developer.</li>
<li>Provided API to access all inner image data structure and 2D transform.</li>
</ul>


<h2>Future Work</h2>
<ul>

<li>Add new image processing algorithm. This can be done by adding new delegate.</li>

<li>Add new tool to toolkit panel. This can be done by implement session
  interface.</li>

<li>Enhance Image I/O support. This can be down by implement new image loader.</li>

<li>Refine the GUI.</li>

<li>Make use of Java native interface to wrap up native image processing
  libraries and access hardware directly. One possibility is to make use of
  OpenGL library to take advantage of different system.</li>

</ul>

<h2>Some useful web page</h2>
<ul>

<li>Computational geography introduction <a href="http://www.cs.mtu.edu/~shene/COURSES/cs3621/NOTES/notes.html">notes</a>.</li>

<li>Ibiblio <a href="http://www.ibiblio.org/e-notes/">notes</a> for spline, also
  all <a href="src/Java.zip">java source</a> and <a href="src/Splines.zip">spline
  source</a> are free.</li>

<li>Add new tool to toolkit panel. This can be done by implement session
  interface.</li>
</ul>



</body>

</html>
